#### Purpose:
## To purchase a Xbox One for my cousin. I wanted to find a decent price and have a CSV emailed
## to me every morning with listings that matched my criteria. 

#### Value:
## Saved me hours of searching! I actually gave the script to him directly and he ended up finding the 
## exact Xbox he wanted.

#### Data:
## Craigslist has sinced changed some elements that are used for building the CSV. Let me know if you'd like
## Me to update this and get it fully functioning!

require 'rubygems'
require 'mechanize'
require 'csv'

scraper = Mechanize.new

# Mechanize setup to rate limit your scraping to once every half-second
scraper.history_added = Proc.new { sleep 0.5 }

# hard-coding an address for your scraper
ADDRESS = 'http://austin.craigslist.org/search/sss'

results = []
results << ['#', 'Name', 'URL', 'Price', 'Location']


# SCRAPING TIME
scraper.get(ADDRESS) do |search_page|

  # work with the form
  form = search_page.form_with(:id => 'searchform') do |search|
    search.query = 'Xbox One'
    search.min_price = 250
    search.max_price = 400
    search.checkbox_with(:name => 'hasPic').check
    search.checkbox_with(:name => 'searchNearby').check
  end
  result_page = form.submit

  # get the results
  raw_results = result_page.search('p.row')
  #parse the results
  counter = 1
  raw_results.each do |result|
    link = result.css('a')[1]
    name = link.text.strip
    url = "http://austin.craigslist.org" + link.attributes["href"].value
    price = result.search('span.price').text[0..3]
    location = result.search('span.pnr').text[3..-13]

    if location.include? 'Austin'
 p  results << [counter, name, url, price, location]
   counter += 1
    end
  end
end


CSV.open('xboxone.csv', 'w+') do |csv_file|
  results.each do |row|
    csv_file << row
  end
end
