#### Purpose:
## To purchase clothes really, really, quickly.
## A good friend of mine wanted to build a script that would purchase clothes from SupremeNewYork the second they were released.

#### Value:
## Be the first to have the clothing in sizes you can can actually wear. 

#### Data:
## I believe that this can still be run. I wrote everything you see below, however I no longer maintain this 'project'.

require 'rubygems'
require 'watir-webdriver'
require 'webdriver-user-agent'
require 'nokogiri'
require 'mechanize'
require 'open-uri'
require 'yaml'

begin

  class Supreme

    def self.connect(url)
      @m = Mechanize.new
      m = @m
      m.user_agent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/48.0.2564.116 Safari/537.36'
      m.get(url) do |x|
        @page = x
      end
    end

    def self.availableItems(url)
      Supreme::connect(url)
      itemIDs = []
      availableItems = []
      ignore = ['Supreme','view cart','view/edit cart','checkout now','all','jackets','shirts','tops/sweaters','sweatshirts','pants','t-shirts','hats','bags','accessories',
                'skate','sold out','home','shop','view all','sizing','terms','f.a.q.']
      page = @page
      link = @page.links

      link.each do |l|
        id = l.to_s
        unless ignore.include?(id)
          itemIDs << id
        end
      end
      itemIDs.each do |av|
        item = page.link_with(:text => av).href
        availableItems << item
      end
      @itemURI = availableItems
    end

    def self.sortItems(url,itemArray)
      #options = jackets, shirts, pants, hats, accessories, skate, sweaters, other
      cop = []
      Supreme::availableItems(url + 'shop/all.html')
      itemURI = @itemURI
      itemURI.each do |i|
        Supreme::connect(url + i)
        s = i.split('/')[2]
        itemArray.each do |item|
          if s == item
            cop << "#{url.chomp('/')}#{i}"
          end
        end if itemArray.any?
      end
      p @cop = cop
    end

    def self.addtoCartandCheckout(url, yaml)
      prefSize, itemArray, card, address = Supreme::readYAML(yaml)
      Supreme::sortItems(url,itemArray)
      b = Watir::Browser.new :chrome
      @cop.each do |c|
        b.goto "#{c}"
        begin
          sizeArray = b.select_list(:id, 'size').text.split
        rescue
          p "Limited to 1 of each style. (#{c})"
          next
        end
        sizeArray = b.select_list(:id, 'size').text.split
        prefSize = prefSize & sizeArray # What's available
        if prefSize.empty?
          puts 'None of your sizes are available.'
        else
          prefSize.each do |a|
            sleep(1)
            b.select_list(:id => 'size').option(:text => a).select # Select our desired sizes

          end
        end
        sleep(0.5)
        b.button(:xpath => '//*[@id="add-remove-buttons"]/input').click # Add to Cart
      end

      b.goto 'https://www.supremenewyork.com/checkout'

      address.each do |k, v|
        if k == 'billing_state'
          b.select_list(:name => 'order[billing_state]').select v
        else
          b.text_field(:name => "order[#{k}]").set v
        end
      end

      card.each do |k, v|
        if %w(type month year).include?(k)
          b.select_list(:name => "credit_card[#{k}]").select v
        else
          b.text_field(:name => "credit_card[#{k}]").set v
        end
      end

      b.driver.action.move_to(b.checkbox(:name => 'order[terms]').wd,0,0).click.perform
      b.button(:name => 'commit').click
    end

    def self.readYAML(yaml)
      config = YAML.load_file(yaml)
      return config['pref_size'], config['items'], config['card'], config['address']
    end

  rescue OpenURI::HTTPError => e
    if e.message != '200'
      raise e
    end
  end
end

Supreme::addtoCartandCheckout('http://www.supremenewyork.com/', 'Supreme.yml')